Index: squid/src/webpush.c
diff -u /dev/null squid/src/webpush.c:1.1.2.2
--- /dev/null	Mon Jan 26 04:57:39 2004
+++ squid/src/webpush.c	Fri Dec 14 00:00:37 2001
@@ -0,0 +1,267 @@
+#include <stdio.h>
+#include <string.h>
+#include <fcntl.h>
+#include <time.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+
+#define OUTBUFLEN 65536
+/*#define OUTBUFLEN 1400*/
+
+char *malloc();
+void free();
+int atoi();
+int gethostname();
+int write();
+
+void usage();
+int puthdr(struct stat *st);
+void hfcopy(FILE *to, FILE *from, char *buf, int buflen, int hdrlen);
+
+char *verstr = "Server: Webpush 2.0, Squid PUT utility\r\n";
+
+static int port = 3128;
+static int verbose = 0;
+static int directfile = 0;
+static int async = 0;
+
+static char *cmdname;
+static char name[256];
+static char reply[BUFSIZ];
+static char *url = 0;
+static char *htfile = 0;
+static char *type = "text/html";
+static char outbuf[OUTBUFLEN];
+
+int main(argc, argv)
+int argc;
+char **argv;
+{
+    struct sockaddr_in addr;
+    int argcnt = 0;
+    struct stat st;
+    FILE *sp, *fp;
+    int hdrlen;
+    char *arg;
+    int code;
+    int s;
+    
+    cmdname = argv[0];
+    if (argc < 3)
+	usage();
+    while (--argc) {
+	arg = *++argv;
+	if (arg[0] == '-') {
+	    while (*++arg) {
+		switch(*arg) {
+		  case 'a':   /* Asynchronous - don't wait for reply */
+		    async = 1;
+		    break;
+		  case 'h':   /* Don't generate HTTP headers - already in file */
+		    directfile = 1;
+		    break;
+		  case 'p':   /* Specify port */
+		    --argc;
+		    if (argc < 1)
+			usage();
+		    port = atoi(*++argv);
+		    if (port == 0)
+			usage();
+		    break;
+		  case 't':   /* Specify Content-type */
+		    --argc;
+		    if (argc < 1)
+			usage();
+		    type = *++argv;
+			usage();
+		    break;
+		  case 'v':   /* Verbose */
+		    verbose = 1;
+		    break;
+		  default:
+		    usage();
+		}
+	    }
+	}
+	else {
+	    ++argcnt;
+	    if (argcnt == 1) {
+		/* First non-flagged arg is the URL */
+		url = arg;
+	    }
+	    else if (argcnt == 2) {
+		/* Second non-flagged arg is the file to push */
+		htfile = arg;
+	    }
+	    else
+		usage();
+	}
+    }
+
+    if (argcnt != 2)
+	usage();
+
+    s = socket(AF_INET, SOCK_STREAM, 0);
+    if (s == -1) {
+	perror("socket");
+	exit(1);
+    }
+
+    addr.sin_family = AF_INET;
+    addr.sin_addr.s_addr = htonl(0x7f000001);
+    addr.sin_port = htons(port);
+    if (connect(s, (struct sockaddr *) &addr, sizeof(addr)) == -1) {
+	perror("connect");
+	exit(1);
+    }
+    sp = fdopen(s, "r+");
+    if (sp == NULL) {
+	perror("socket fdopen");
+	exit(1);
+    }
+    
+    fp = fopen(htfile, "r");
+    if (fp == 0) {
+	perror(htfile);
+	exit(1);
+    }
+    
+    if (fstat(fileno(fp), &st) == -1) {
+	perror("fstat");
+	exit(1);
+    }
+
+    /* If directfile, then the file will already have HTTP headers */
+    if (!directfile) {
+	/* Generate header and send to proxy */
+	hdrlen = puthdr(&st);
+	if (verbose) {
+	    fwrite(outbuf, 1, hdrlen, stdout);
+	}
+    }
+
+    /* Copy file to proxy */
+    if (verbose)
+	printf("sending file to proxy\n");
+    hfcopy(sp, fp, outbuf, OUTBUFLEN, hdrlen);
+
+    /* Read response */
+    if (!async) {
+	if (verbose)
+	    printf("proxy response is:\n");
+	fread(reply, 1, sizeof(reply), sp);
+	reply[sizeof(reply) - 2] = '\n';
+	reply[sizeof(reply) - 1] = '\0';
+
+	/* Parse response */
+	sscanf(reply, "%s %d", name, &code);
+	
+	/* Print the complaint if the server seems unhappy */
+	if ((code != 200 && code != 204) || verbose)
+	    fputs(reply, stdout);
+    }
+    exit(0);
+}
+
+void usage(err)
+char *err;
+{
+    fprintf(stderr, "usage: %s [-h][-p port][-t content-type] <url> <file-to-push>\n", cmdname);
+    exit(1);
+}
+
+/* Generate PUT header */
+int puthdr(statp)
+struct stat *statp;
+{
+    struct tm *gmtime();
+    char *asctime();
+    char *timestr;
+    time_t now;
+    int hdrlen;
+
+    now = time(0);
+    timestr = asctime(gmtime(&now));
+    timestr[strlen(timestr) - 1] = '\0';
+
+    gethostname(name, sizeof(name));
+
+    if (url == 0) {
+	fprintf(stderr, "webpush internal problem - URL unknown\n");
+	exit(1);
+    }
+
+    hdrlen = 0;
+    sprintf(outbuf, "PUT %s HTTP/1.0\r\n", url);
+    hdrlen = strchr(outbuf, '\n') - outbuf + 1;
+    
+    sprintf(outbuf + hdrlen, "Date: %s GMT\r\n", timestr);
+    hdrlen = strchr(outbuf + hdrlen, '\n') - outbuf + 1;
+
+    sprintf(outbuf + hdrlen, verstr);
+    hdrlen = strchr(outbuf + hdrlen, '\n') - outbuf + 1;
+
+    sprintf(outbuf + hdrlen, "Content-type: %s\r\n", type);
+    hdrlen = strchr(outbuf + hdrlen, '\n') - outbuf + 1;
+
+    sprintf(outbuf + hdrlen, "Content-length: %d\r\n", (int) statp->st_size);
+    hdrlen = strchr(outbuf + hdrlen, '\n') - outbuf + 1;
+
+    timestr = asctime(gmtime(&statp->st_mtime));
+    timestr[strlen(timestr) - 1] = '\0';
+    sprintf(outbuf + hdrlen, "Last-modified: %s GMT\r\n\r\n", timestr);
+    hdrlen = strchr(outbuf + hdrlen, '\n') - outbuf + 3;
+
+    if (verbose)
+	printf("PUT header amounts to %d bytes\n", hdrlen);
+    
+    return(hdrlen);
+}
+
+/* filecopy that makes allowances for an initial output header */
+void hfcopy(to, from, buf, buflen, hdrlen)
+FILE *to, *from;
+char *buf;
+int buflen;
+int hdrlen;
+{
+    int nmov, nwrote;
+    char *tbuf;
+
+    while (1) {
+	nmov = fread(buf + hdrlen, 1, buflen - hdrlen, from);
+	if (nmov == -1) {
+	    perror("filecopy read");
+	    exit(1);
+	}
+	if (nmov == 0) {
+	    if (!feof(from))
+		perror("webpost read");
+	    break;
+	}
+	nmov += hdrlen;
+
+	tbuf = buf;
+	do {
+	    if (verbose) 
+		write(1, buf, nmov);
+	    nwrote = write(fileno(to), buf, nmov);
+	    if (nwrote == -1) {
+		perror("filecopy write");
+		exit(1);
+	    }
+	    if (nwrote == 0)
+		break;
+	    nmov -= nwrote;
+	    tbuf += nwrote;
+	} while (nmov > 0);
+
+	/* Sent header in first go-round, done now */
+	hdrlen = 0;
+    }
+    if (verbose)
+	printf("filecopy complete - last move of %d chars\n", nmov);
+}
+
Index: squid/src/auth/basic/helpers/Makefile.am
diff -u /dev/null squid/src/auth/basic/helpers/Makefile.am:1.2.28.1
--- /dev/null	Mon Jan 26 04:57:39 2004
+++ squid/src/auth/basic/helpers/Makefile.am	Tue Sep  3 10:42:05 2002
@@ -0,0 +1,7 @@
+#  Makefile for storage modules in the Squid Object Cache server
+#
+#  $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+#
+
+DIST_SUBDIRS	= getpwnam LDAP MSNT multi-domain-NTLM NCSA PAM SMB YP SASL
+SUBDIRS		= @BASIC_AUTH_HELPERS@
Index: squid/src/auth/basic/helpers/LDAP/Makefile.am
diff -u /dev/null squid/src/auth/basic/helpers/LDAP/Makefile.am:1.2.28.2
--- /dev/null	Mon Jan 26 04:57:39 2004
+++ squid/src/auth/basic/helpers/LDAP/Makefile.am	Tue Sep  3 10:42:07 2002
@@ -0,0 +1,14 @@
+#
+#  Makefile for the Squid LDAP authentication helper
+#
+#  $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+#
+#  Uncomment and customize the following to suit your needs:
+#
+
+libexec_PROGRAMS 	= squid_ldap_auth
+man_MANS 		= squid_ldap_auth.8
+EXTRA_DIST		= squid_ldap_auth.8
+squid_ldap_auth_SOURCES	= squid_ldap_auth.c
+
+LDADD = -lldap -llber
Index: squid/src/auth/basic/helpers/MSNT/Makefile.am
diff -u /dev/null squid/src/auth/basic/helpers/MSNT/Makefile.am:1.2.28.2
--- /dev/null	Mon Jan 26 04:57:39 2004
+++ squid/src/auth/basic/helpers/MSNT/Makefile.am	Tue Sep  3 10:42:10 2002
@@ -0,0 +1,22 @@
+#
+#  Makefile for the Squid Object Cache server
+#
+#  $Id: squid-push-HEAD,v 1.1 2004/08/17 20:55:13 hno Exp $
+#
+#  Uncomment and customize the following to suit your needs:
+#
+
+
+libexec_PROGRAMS = msnt_auth
+
+msnt_auth_SOURCES = md4.c rfcnb-io.c rfcnb-util.c session.c msntauth.c \
+		msntauth.h smbdes.c smbencrypt.c smblib-util.c smblib.c \
+		valid.c denyusers.c allowusers.c confload.c \
+		byteorder.h rfcnb-common.h rfcnb-error.h rfcnb.h \
+		rfcnb-io.h rfcnb-priv.h rfcnb-util.h smblib-common.h \
+		smblib.h smblib-priv.h std-defines.h std-includes.h valid.h
+
+LDADD	= @XTRA_LIBS@
+
+INCLUDES      = -I. -I$(top_builddir)/include -I$(top_srcdir)/include \
+		-I$(top_srcdir)/src/
Index: squid/src/auth/basic/helpers/MSNT/allowusers.c
diff -u /dev/null squid/src/auth/basic/helpers/MSNT/allowusers.c:1.2.62.1
--- /dev/null	Mon Jan 26 04:57:39 2004
+++ squid/src/auth/basic/helpers/MSNT/allowusers.c	Tue Sep  3 10:42:10 2002
@@ -0,0 +1,193 @@
+
+/*
+ * allowusers.c
+ * (C) 2000 Antonino Iannella, Stellar-X Pty Ltd
+ * Released under GPL, see COPYING-2.0 for details.
+ * 
+ * These routines are to allow users attempting to use the proxy which
+ * have been explicitly allowed by the system administrator.
+ * The code originated from denyusers.c.
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <syslog.h>
+#include <unistd.h>
+#include <sys/stat.h>
+#include <errno.h>
+#include <time.h>
+#include <ctype.h>
+#include <sys/param.h>
+
+#define NAMELEN     50		/* Maximum username length */
+
+/* Global variables */
+
+char *AllowedUsers;		/* Pointer to string of allowed users */
+off_t AllowUserSize;		/* Size of allowed users file */
+struct stat FileBuf;		/* Stat data buffer */
+time_t LastModTime;		/* Last allowed user file modification time */
+
+char Allowuserpath[MAXPATHLEN];	/* MAXPATHLEN defined in param.h */
+
+/* Function declarations */
+
+int Read_allowusers();
+int Check_ifuserallowed(char *);
+void Checkforchange();
+void Checktimer();
+
+/*
+ * Reads the allowed users file for all users to be permitted.
+ * Returns 0 if the user list was successfully loaded,
+ * and 1 in case of error.
+ * Logs any messages to the syslog daemon.
+ */
+
+int
+Read_allowusers()
+{
+    FILE *AFile;		/* Allowed users file pointer */
+    off_t APos = 0;		/* File counter */
+    char AChar;			/* Character buffer */
+
+    /* Stat the file. If it does not exist, save the size as zero.
+     * Clear the allowed user string. Return. */
+    if (stat(Allowuserpath, &FileBuf) == -1) {
+	if (errno == ENOENT) {
+	    LastModTime = (time_t) 0;
+	    AllowUserSize = 0;
+	    free(AllowedUsers);
+	    AllowedUsers = malloc(sizeof(char));
+	    AllowedUsers[0] = '\0';
+	    return 0;
+	} else {
+	    syslog(LOG_USER | LOG_ERR, strerror(errno));
+	    return 1;
+	}
+    }
+    /* If it exists, save the modification time and size */
+    LastModTime = FileBuf.st_mtime;
+    AllowUserSize = FileBuf.st_size;
+
+    /* Handle the special case of a zero length file */
+    if (AllowUserSize == 0) {
+	free(AllowedUsers);
+	AllowedUsers = malloc(sizeof(char));
+	AllowedUsers[0] = '\0';
+	return 0;
+    }
+    /* Free and allocate space for a string to store the allowed usernames */
+    free(AllowedUsers);
+
+    if ((AllowedUsers = malloc(sizeof(char) * (AllowUserSize + 3))) == NULL) {
+	syslog(LOG_USER | LOG_ERR, "Read_allowusers: malloc(AllowedUsers) failed.");
+	return 1;
+    }
+    /* Open the allowed users file. Report any errors. */
+
+    if ((AFile = fopen(Allowuserpath, "r")) == NULL) {
+	syslog(LOG_USER | LOG_ERR, "Read_allowusers: Failed to open allowed user file.");
+	syslog(LOG_USER | LOG_ERR, strerror(errno));
+	return 1;
+    }
+    /* Read user names into the AllowedUsers string.
+     * Make sure each string is delimited by a space. */
+
+    AllowedUsers[APos++] = ' ';
+
+    while (!feof(AFile)) {
+	if ((AChar = fgetc(AFile)) == EOF)
+	    break;
+	else {
+	    if (isspace(AChar))
+		AllowedUsers[APos++] = ' ';
+	    else
+		AllowedUsers[APos++] = toupper(AChar);
+	}
+    }
+
+    AllowedUsers[APos++] = ' ';
+    AllowedUsers[APos] = '\0';
+    fclose(AFile);
+    return 0;
+}
+
+/*
+ * Check to see if the username provided by Squid appears in the allowed
+ * user list. Returns 0 if the user was not found, and 1 if they were.
+ */
+
+int
+Check_ifuserallowed(char *ConnectingUser)
+{
+    static char CUBuf[NAMELEN + 1];
+    static char CUBuf1[NAMELEN + 1];
+    static int x;
+    static char AllowMsg[256];
+
+    /* If user string is empty, allow */
+    if (ConnectingUser[0] == '\0')
+	return 1;
+
+    /* If allowed user list is empty, allow all users.
+     * If no users are supposed to be using the proxy, stop squid instead. */
+    if (AllowUserSize == 0)
+	return 1;
+
+    /* Check if username string is found in the allowed user list.
+     * If so, allow. If not, deny. Reconstruct the username
+     * to have whitespace, to avoid finding wrong string subsets. */
+
+    sscanf(ConnectingUser, " %s ", CUBuf1);
+    sprintf(CUBuf, " %s ", CUBuf1);
+
+    for (x = 0; x <= strlen(CUBuf); x++)
+	CUBuf[x] = toupper(CUBuf[x]);
+
+    if (strstr(AllowedUsers, CUBuf) != NULL)
+	return 1;
+    else {			/* If NULL, they are not allowed to use the proxy */
+	sprintf(AllowMsg, "Did not allow access to user '%s'.", CUBuf1);
+	syslog(LOG_USER | LOG_ERR, AllowMsg);
+	return 0;
+    }
+}
+
+/*
+ * Checks if there has been a change in the allowed users file.
+ * If the modification time has changed, then reload the allowed user list.
+ * This function is called by the SIGHUP signal handler.
+ */
+
+void
+Check_forallowchange()
+{
+    struct stat ChkBuf;		/* Stat data buffer */
+
+    /* Stat the allowed users file. If it cannot be accessed, return. */
+
+    if (stat(Allowuserpath, &ChkBuf) == -1) {
+	if (errno == ENOENT) {
+	    LastModTime = (time_t) 0;
+	    AllowUserSize = 0;
+	    free(AllowedUsers);
+	    AllowedUsers = malloc(sizeof(char));
+	    AllowedUsers[0] = '\0';
+	    return;
+	} else {		/* Report error when accessing file */
+	    syslog(LOG_USER | LOG_ERR, strerror(errno));
+	    return;
+	}
+    }
+    /* If found, compare the modification time with the previously-recorded
+     * modification time.
+     * If the modification time has changed, reload the allowed user list.
+     * Log a message of its actions. */
+
+    if (ChkBuf.st_mtime != LastModTime) {
+	syslog(LOG_USER | LOG_INFO, "Check_forallowchange: Reloading allowed user list.");
+	Read_allowusers();
+    }
+}
Index: squid/src/auth/basic/helpers/MSNT/confload.c
diff -u /dev/null squid/src/auth/basic/helpers/MSNT/confload.c:1.2.62.1
--- /dev/null	Mon Jan 26 04:57:39 2004
+++ squid/src/auth/basic/helpers/MSNT/confload.c	Tue Sep  3 10:42:11 2002
@@ -0,0 +1,249 @@
+
+/*
+ * confload.c
+ * (C) 2000 Antonino Iannella, Stellar-X Pty Ltd
+ * Released under GPL, see COPYING-2.0 for details.
+ * 
+ * These routines load the msntauth configuration file.
+ * It stores the servers to query, sets the denied and
+ * allowed user files, and provides the 
+ * authenticating function.
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <syslog.h>
+#include <errno.h>
+#include <sys/param.h>
+#include <netdb.h>
+
+#include "msntauth.h"
+#include "valid.h"
+
+#define CONFIGFILE   "/usr/local/squid/etc/msntauth.conf"	/* Path to configuration file */
+#define DENYUSERSDEFAULT   "/usr/local/squid/etc/denyusers"
+#define ALLOWUSERSDEFAULT  "/usr/local/squid/etc/allowusers"
+
+#define MAXSERVERS 5		/* Maximum number of servers to query. This number can be increased. */
+#define NTHOSTLEN 65
+
+extern char Denyuserpath[MAXPATHLEN];	/* MAXPATHLEN defined in param.h */
+extern char Allowuserpath[MAXPATHLEN];
+
+typedef struct _ServerTuple {
+    char pdc[NTHOSTLEN];
+    char bdc[NTHOSTLEN];
+    char domain[NTHOSTLEN];
+} ServerTuple;
+
+ServerTuple ServerArray[MAXSERVERS];	/* Array of servers to query */
+int Serversqueried = 0;		/* Number of servers queried */
+
+/* Declarations */
+
+static void ProcessLine(char *);
+static void AddServer(char *, char *, char *);
+static int QueryServerForUser(int, char *, char *);
+
+/*
+ * Opens and reads the configuration file.
+ * Returns 0 on success, or 1 for error.
+ */
+
+int
+OpenConfigFile(void)
+{
+    FILE *ConfigFile;
+    char Confbuf[2049];		/* Line reading buffer */
+
+    /* Initialise defaults */
+
+    Serversqueried = 0;
+    strcpy(Denyuserpath, DENYUSERSDEFAULT);
+    strcpy(Allowuserpath, ALLOWUSERSDEFAULT);
+
+    /* Open file */
+    if ((ConfigFile = fopen(CONFIGFILE, "r")) == NULL) {
+	syslog(LOG_USER | LOG_ERR, "OpenConfigFile: Failed to open %s.", CONFIGFILE);
+	syslog(LOG_USER | LOG_ERR, strerror(errno));
+	return 1;
+    }
+    /* Read in, one line at a time */
+
+    while (!feof(ConfigFile)) {
+	Confbuf[0] = '\0';
+	fgets(Confbuf, 2049, ConfigFile);
+	ProcessLine(Confbuf);
+    }
+
+    /* Check that at least one server is being queried. Report error if not.
+     * Denied and allowed user files are hardcoded, so it's fine if they're
+     * not set in the confugration file. */
+
+    if (Serversqueried == 0) {
+	syslog(LOG_USER | LOG_ERR, "OpenConfigFile: No servers set in %s. At least one is needed.", CONFIGFILE);
+	return 1;
+    }
+    fclose(ConfigFile);
+    return 0;
+}
+
+/* Parses a configuration file line. */
+
+static void
+ProcessLine(char *Linebuf)
+{
+    char *Directive;
+    char *Param1;
+    char *Param2;
+    char *Param3;
+
+    /* Ignore empty lines */
+    if (strlen(Linebuf) == 0)
+	return;
+
+    /* Break up on whitespaces */
+    if ((Directive = strtok(Linebuf, " \t\n")) == NULL)
+	return;
+
+    /* Check for a comment line. If found, stop . */
+    if (Directive[0] == '#')
+	return;
+
+    /* Check for server line. Check for 3 parameters. */
+    if (strcasecmp(Directive, "server") == 0) {
+	Param1 = strtok(NULL, " \t\n");
+	Param2 = strtok(NULL, " \t\n");
+	Param3 = strtok(NULL, " \t\n");
+
+	if ((Param1[0] == '\0') ||
+	    (Param2[0] == '\0') ||
+	    (Param3[0] == '\0')) {
+	    syslog(LOG_USER | LOG_ERR, "ProcessLine: A 'server' line needs PDC, BDC, and domain parameters.");
+	    return;
+	}
+	AddServer(Param1, Param2, Param3);
+	return;
+    }
+    /* Check for denyusers line */
+    if (strcasecmp(Directive, "denyusers") == 0) {
+	Param1 = strtok(NULL, " \t\n");
+
+	if (Param1[0] == '\0') {
+	    syslog(LOG_USER | LOG_ERR, "ProcessLine: A 'denyusers' line needs a filename parameter.");
+	    return;
+	}
+	strcpy(Denyuserpath, Param1);
+	return;
+    }
+    /* Check for allowusers line */
+    if (strcasecmp(Directive, "allowusers") == 0) {
+	Param1 = strtok(NULL, " \t\n");
+
+	if (Param1[0] == '\0') {
+	    syslog(LOG_USER | LOG_ERR, "ProcessLine: An 'allowusers' line needs a filename parameter.");
+	    return;
+	}
+	strcpy(Allowuserpath, Param1);
+	return;
+    }
+    /* Reports error for unknown line */
+    syslog(LOG_USER | LOG_ERR, "ProcessLine: Ignoring '%s' line.", Directive);
+}
+
+/*
+ * Adds a server to query to the server array.
+ * Checks if the server IP is resolvable.
+ * Checks if the number of servers to query is not exceeded.
+ * Does not allow parameters longer than NTHOSTLEN.
+ */
+
+void
+AddServer(char *ParamPDC, char *ParamBDC, char *ParamDomain)
+{
+    if (Serversqueried + 1 > MAXSERVERS) {
+	syslog(LOG_USER | LOG_ERR, "AddServer: Ignoring '%s' server line; too many servers.", ParamPDC);
+	return;
+    }
+    if (gethostbyname(ParamPDC) == (struct hostent *) NULL) {
+	syslog(LOG_USER | LOG_ERR, "AddServer: Ignoring host '%s'. Cannot resolve its address.", ParamPDC);
+	return;
+    }
+    if (gethostbyname(ParamBDC) == (struct hostent *) NULL) {
+	syslog(LOG_USER | LOG_ERR, "AddServer: Ignoring host '%s'. Cannot resolve its address.", ParamBDC);
+	return;
+    }
+    Serversqueried++;
+    strncpy(ServerArray[Serversqueried].pdc, ParamPDC, NTHOSTLEN);
+    strncpy(ServerArray[Serversqueried].bdc, ParamBDC, NTHOSTLEN);
+    strncpy(ServerArray[Serversqueried].domain, ParamDomain, NTHOSTLEN);
+    ServerArray[Serversqueried].pdc[NTHOSTLEN - 1] = '\0';
+    ServerArray[Serversqueried].bdc[NTHOSTLEN - 1] = '\0';
+    ServerArray[Serversqueried].domain[NTHOSTLEN - 1] = '\0';
+}
+
+/*
+ * Cycles through all servers to query.
+ * Returns 0 if one server could authenticate the user.
+ * Returns 1 if no server authenticated the user.
+ */
+
+int
+QueryServers(char *username, char *password)
+{
+    int Queryresult = 1;	/* Default result is an error */
+    int x = 1;
+
+    while (x <= Serversqueried) {	/* Query one server. Change Queryresult if user passed. */
+	if (QueryServerForUser(x++, username, password) == 0) {
+	    Queryresult = 0;
+	    break;
+	}
+    }
+
+    return Queryresult;
+}
+
+/*
+ * Attempts to authenticate the user with one server.
+ * Logs syslog messages for different errors.
+ * Returns 0 on success, non-zero on failure.
+ */
+
+/* Define for systems which don't support it, like Solaris */
+#ifndef LOG_AUTHPRIV
+#define LOG_AUTHPRIV LOG_AUTH
+#endif
+
+int
+QueryServerForUser(int x, char *username, char *password)
+{
+    int result = 1;
+
+    result = Valid_User(username, password, ServerArray[x].pdc,
+	ServerArray[x].bdc, ServerArray[x].domain);
+
+    switch (result) {		/* Write any helpful syslog messages */
+    case 0:
+	break;
+    case 1:
+	syslog(LOG_AUTHPRIV | LOG_INFO, "Server error when checking %s.", username);
+	break;
+    case 2:
+	syslog(LOG_AUTHPRIV | LOG_INFO, "Protocol error when checking %s.", username);
+	break;
+    case 3:
+	syslog(LOG_AUTHPRIV | LOG_INFO, "Authentication failed for %s.", username);
+    }
+
+    return result;
+}
+
+/* Valid_User return codes -
+ * 
+ * 0 - User authenticated successfully.
+ * 1 - Server error.
+ * 2 - Protocol error.
+ * 3 - Logon error; Incorrect password or username given.
+ */
Index: squid/src/auth/basic/helpers/MSNT/denyusers.c
diff -u /dev/null squid/src/auth/basic/helpers/MSNT/denyusers.c:1.2.62.1
--- /dev/null	Mon Jan 26 04:57:39 2004
+++ squid/src/auth/basic/helpers/MSNT/denyusers.c	Tue Sep  3 10:42:11 2002
@@ -0,0 +1,250 @@
+
+/*
+ * denyusers.c
+ * (C) 2000 Antonino Iannella, Stellar-X Pty Ltd
+ * Released under GPL, see COPYING-2.0 for details.
+ * 
+ * These routines are to block users attempting to use the proxy which
+ * have been explicitly denied by the system administrator.
+ * Routines at the bottom also use the allowed user functions.
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <syslog.h>
+#include <unistd.h>
+#include <sys/stat.h>
+#include <errno.h>
+#include <time.h>
+#include <ctype.h>
+#include <sys/param.h>
+
+#define NAMELEN     50		/* Maximum username length */
+
+/* Global variables */
+
+char *DeniedUsers;		/* Pointer to string of denied users */
+off_t DenyUserSize;		/* Size of denied user file */
+struct stat FileBuf;		/* Stat data buffer */
+time_t LastModTime;		/* Last denied user file modification time */
+
+char Denyuserpath[MAXPATHLEN];	/* MAXPATHLEN defined in param.h */
+
+/* Function declarations */
+
+int Read_denyusers();
+int Check_ifuserdenied(char *);
+int Check_user(char *);
+void Checktimer();
+void Check_forchange();
+void Check_fordenychange();
+extern void Check_forallowchange();	/* For allowed users */
+extern int Check_ifuserallowed(char *);
+
+/*
+ * Reads Denyuserpath for all users to be excluded.
+ * Returns 0 if the user list was successfully loaded,
+ * and 1 in case of error.
+ * Logs any messages to the syslog daemon.
+ */
+
+int
+Read_denyusers()
+{
+    FILE *DFile;		/* Denied user file pointer */
+    off_t DPos = 0;		/* File counter */
+    char DChar;			/* Character buffer */
+
+    /* Stat the file. If it does not exist, save the size as zero.
+     * Clear the denied user string. Return. */
+    if (stat(Denyuserpath, &FileBuf) == -1) {
+	if (errno == ENOENT) {
+	    LastModTime = (time_t) 0;
+	    DenyUserSize = 0;
+	    free(DeniedUsers);
+	    DeniedUsers = malloc(sizeof(char));
+	    DeniedUsers[0] = '\0';
+	    return 0;
+	} else {
+	    syslog(LOG_USER | LOG_ERR, strerror(errno));
+	    return 1;
+	}
+    }
+    /* If it exists, save the modification time and size */
+    LastModTime = FileBuf.st_mtime;
+    DenyUserSize = FileBuf.st_size;
+
+    /* Handle the special case of a zero length file */
+    if (DenyUserSize == 0) {
+	free(DeniedUsers);
+	DeniedUsers = malloc(sizeof(char));
+	DeniedUsers[0] = '\0';
+	return 0;
+    }
+    /* Free and allocate space for a string to store the denied usernames */
+    free(DeniedUsers);
+
+    if ((DeniedUsers = malloc(sizeof(char) * (DenyUserSize + 3))) == NULL) {
+	syslog(LOG_USER | LOG_ERR, "Read_denyusers: malloc(DeniedUsers) failed.");
+	return 1;
+    }
+    /* Open the denied user file. Report any errors. */
+
+    if ((DFile = fopen(Denyuserpath, "r")) == NULL) {
+	syslog(LOG_USER | LOG_ERR, "Read_denyusers: Failed to open denied user file.");
+	syslog(LOG_USER | LOG_ERR, strerror(errno));
+	return 1;
+    }
+    /* Read user names into the DeniedUsers string.
+     * Make sure each string is delimited by a space. */
+
+    DeniedUsers[DPos++] = ' ';
+
+    while (!feof(DFile)) {
+	if ((DChar = fgetc(DFile)) == EOF)
+	    break;
+	else {
+	    if (isspace(DChar))
+		DeniedUsers[DPos++] = ' ';
+	    else
+		DeniedUsers[DPos++] = toupper(DChar);
+	}
+    }
+
+    DeniedUsers[DPos++] = ' ';
+    DeniedUsers[DPos] = '\0';
+    fclose(DFile);
+    return 0;
+}
+
+/*
+ * Check to see if the username provided by Squid appears in the denied
+ * user list. Returns 0 if the user was not found, and 1 if they were.
+ */
+
+int
+Check_ifuserdenied(char *ConnectingUser)
+{
+    static char CUBuf[NAMELEN + 1];
+    static char CUBuf1[NAMELEN + 1];
+    static int x;
+    static char DenyMsg[256];
+
+    /* If user string is empty, deny */
+    if (ConnectingUser[0] == '\0')
+	return 1;
+
+    /* If denied user list is empty, allow */
+    if (DenyUserSize == 0)
+	return 0;
+
+    /* Check if username string is found in the denied user list.
+     * If so, deny. If not, allow. Reconstruct the username
+     * to have whitespace, to avoid finding wrong string subsets. */
+
+    sscanf(ConnectingUser, " %s ", CUBuf1);
+    sprintf(CUBuf, " %s ", CUBuf1);
+
+    for (x = 0; x <= strlen(CUBuf); x++)
+	CUBuf[x] = toupper(CUBuf[x]);
+
+    if (strstr(DeniedUsers, CUBuf) == NULL)
+	return 0;
+    else {
+	sprintf(DenyMsg, "Denied access to user '%s'.", CUBuf1);
+	syslog(LOG_USER | LOG_ERR, DenyMsg);
+	return 1;
+    }
+}
+
+/*
+ * Checks if there has been a change in the denied user file.
+ * If the modification time has changed, then reload the denied user list.
+ * This function is called by the SIGHUP signal handler.
+ */
+
+void
+Check_fordenychange()
+{
+    struct stat ChkBuf;		/* Stat data buffer */
+
+    /* Stat the denied user file. If it cannot be accessed, return. */
+
+    if (stat(Denyuserpath, &ChkBuf) == -1) {
+	if (errno == ENOENT) {
+	    LastModTime = (time_t) 0;
+	    DenyUserSize = 0;
+	    free(DeniedUsers);
+	    DeniedUsers = malloc(sizeof(char));
+	    DeniedUsers[0] = '\0';
+	    return;
+	} else {		/* Report error when accessing file */
+	    syslog(LOG_USER | LOG_ERR, strerror(errno));
+	    return;
+	}
+    }
+    /* If found, compare the modification time with the previously-recorded
+     * modification time.
+     * If the modification time has changed, reload the denied user list.
+     * Log a message of its actions. */
+
+    if (ChkBuf.st_mtime != LastModTime) {
+	syslog(LOG_USER | LOG_INFO, "Check_fordenychange: Reloading denied user list.");
+	Read_denyusers();
+    }
+}
+
+/*
+ * Decides if a user is denied or allowed.
+ * If they have been denied, or not allowed, return 1.
+ * Else return 0.
+ */
+
+int
+Check_user(char *ConnectingUser)
+{
+    if (Check_ifuserdenied(ConnectingUser) == 1)
+	return 1;
+
+    if (Check_ifuserallowed(ConnectingUser) == 0)
+	return 1;
+
+    return 0;
+}
+
+/*
+ * Checks the denied and allowed user files for change.
+ * This function is invoked when a SIGHUP signal is received.
+ * It is also run after every 60 seconds, at the next request.
+ */
+
+void
+Check_forchange()
+{
+    Check_fordenychange();
+    Check_forallowchange();
+}
+
+/*
+ * Checks the timer. If longer than 1 minute has passed since the last
+ * time someone has accessed the proxy, then check for changes in the
+ * denied user file. If longer than one minute hasn't passed, return.
+ */
+
+void
+Checktimer()
+{
+    static time_t Lasttime;	/* The last time the timer was checked */
+    static time_t Currenttime;	/* The current time */
+
+    Currenttime = time(NULL);
+
+    /* If timeout has expired, check the denied user file, else return */
+    if (difftime(Currenttime, Lasttime) < 60)
+	return;
+    else {
+	Check_forchange();
+	Lasttime = Currenttime;
+    }
+}
Index: squid/src/auth/basic/helpers/MSNT/msntauth-v2.0.lsm
diff -u /dev/null squid/src/auth/basic/helpers/MSNT/msntauth-v2.0.lsm:1.2.62.1
--- /dev/null	Mon Jan 26 04:57:39 2004
+++ squid/src/auth/basic/helpers/MSNT/msntauth-v2.0.lsm	Tue Sep  3 10:42:11 2002
@@ -0,0 +1,13 @@
+Begin3
+Title:         msntauth 
+Version:       2.0 
+Entered-date:  01SEP01 
+Description:   Squid web proxy NT domain authentication module 
+Keywords:      Squid WWW proxy SMB NT domain authentication module source
+Author:         antonino@rager.com.au (Antonino Iannella)
+Maintained-by:  antonino@rager.com.au (Antonino Iannella)
+Primary-site:   sunsite.unc.edu /pub/Linux/system/network/misc
+		msntauth-v2.0.tgz
+Original-site:  http://members.tripod.com/stellarx
+Copying-policy: GPL
+End
